#win-version 1.2

use LWP;
use File::Basename;
use File::Spec;

use strict;

my $JRU = 'http://www.journals.ru';
my $JURL = 'http://www.journals.ru/journals.php?userid=';
my $JPage = 1;		##Nomer stranicy
my $JEnd = 0;		##Flag okonchaniya raboty
my $UserID = $ARGV[0];		##Nomer pol'zovatelya

##Chasti ime'n faylov; trebuyutsya dlya dinamicheskogo sozdaniya
##imeni s identifikatorom
my $PageFileName = 'page';		##Chast' imeni stranichnogo fayla 
my $CommDesc = 'comm';		##Chast' imeni fayla-kommentariya

my $CommInd;		##Soderzhit indeks tekush'ego kommentariya
my $CommAddr;	##Zdes' xranitsya adres tekush'ego kommentariya

##Peremennye-stroki dlya zapisi obrabatyvaemoy stroki
##dlya stranicy i kommentariya sootvetstvenno
my ($PageString, $CommString);

my $PicName;		##Imya kartinki
my $PicLocalUrl;	##URL kartinki, naxodyash'eysya na servere Journals.ru
my $PicPath;		##Polnyi put' k kartinke

##Imena papok; 
## 'comm' 	-- kommentarii
## 'pic' 		-- kartinki na stranice
## 'cpic' 		-- kartinki iz kommentariev
my $CommDir = 'comm';
my $PicDir = 'pic';
my $PicDir2 = 'cpic';

my $Buff;		##Xranit adres kartinki
my $AddExt;	##Rasshirenie kartinki

my $PageIndex = 1; ##Nachal'nyi index stranicy
my @MoreCommURLArr; ##Massiv dlya URL'ov stranic s kommentariyami
my @MoreCommArr;

$JURL .= $UserID;	##URL dnevnika

##Zapros
my $ua = LWP::UserAgent->new;

             while (1)
{
	my $Redo = 0;
	print "\nID dnevnika:";
	$UserID = <STDIN>;
	chomp($UserID);
        
        $JURL .= $UserID;
       
	my $req = HTTP::Request->new(GET=>$JURL);
	my $res = $ua->request($req);

	if (!$res->is_success)
	{
		print "\nZaprashivaemyi dnevnik ne nayden!";
		while (1)
		{
			print "\nPopytaetes' eshe' raz? (y - eshe' raz; n - vyxod) ";
			my $YN = <STDIN>;
			chomp($YN);
			if ($YN eq 'y') { $Redo = 1; last; }
			elsif ( $YN eq 'n') { die "\n"; }
			else { print "\nNepravil'nyi variant otveta!"; redo;};
		};
	}
	else { last; };
	
	if ($Redo == 1) { redo; };
};

##Shablon URLa stranicy
my $PageURLs = $JRU."/journals.php?userid=$UserID"."&page=";

##Sozdanie papok
mkdir($PicDir);
mkdir($CommDir);
chdir($CommDir);
mkdir($PicDir2);
chdir("..");

##Glavnyi cykl
while ( $JEnd != 1)
{
	my $PageURL = $PageURLs . $JPage;	##URL stranicy
	my $JRequest = HTTP::Request->new(GET=>$PageURL);
	my $JResponse = $ua->request($JRequest);
	
	if (!$JResponse->is_success) { $JEnd = 1;};
	
	my $PageFileNameW;	##Imya stranichnogo fayla
	$PageFileNameW = $PageIndex . '.html';
	open(WPAGE, "> $PageFileNameW") or die "$!";	##Zapis' v konechnyi fayl
	$PageIndex++;
	##Proverka tekush'ey stroki
	my @PageStrArr = split(/\n/, $JResponse->content); ##Razbivka kontenta na stroki
	foreach $PageString (@PageStrArr)
	{
	  	my $MoreCounter = 1;	##Nomer stranicy kommentariev
	  	##Opredelenie kommentariya
		if ($PageString =~ m/<a href="(.+)">.+<\/a>.*\[<b>\d+<\/b>(.*)?\]/)
		{
			$CommAddr = $1; 	##Adres kommentariev esli stranica odna
			my $MoreCommAddr = $2; ##Stroka s adresami stranic kommentariev
			my $MoreFlag = 0; ##Esli stranic neskol'ko - 1, esli odna - 0

   		##Sozdanie massiva s adresami stranic kommentariev
			if ($MoreCommAddr)
			{
				$MoreCommAddr =~ s/(: )//;
				$MoreCommAddr =~ s/> </>!</g;
				@MoreCommArr = split(/!/,$MoreCommAddr);
				foreach (@MoreCommArr)
				{
					$_ =~ m/<a href="(.+)">/;
					push(@MoreCommURLArr, $1);
				};

				$MoreFlag = 1;
			};
         ##Esli kommentarii pomesh'ayutsya na odnu stranicu
			if ($MoreFlag == 0) { push(@MoreCommURLArr, $CommAddr); };
			
			##Zakachka kommentariev
			foreach $CommAddr (@MoreCommURLArr)
			{
				my $CommReq = HTTP::Request->new(GET=>"$JRU$CommAddr");
				my $CommResp = $ua->request($CommReq);

				##Opredelenie indeksa kommentariya
				if ($MoreFlag == 0 )
				{
					$CommAddr =~ m/(\d{6}$)/;
					$CommInd = $1;
				}
				else 
				{
					$CommAddr =~ m/(\d{6}&page=(\d*))/;
					$MoreCounter = $2;
					$CommInd = $1;
					$CommInd =~ s/&/-/;
					$CommInd =~ s/=//;
				};

				$CommInd .= '.html';
				##Sozdanie local'noy ssylki
				my $CommPath = $CommDir.'/'.$CommInd;
				if ($MoreFlag == 0) { $PageString =~ s/<a href=".+">(.+)<\/a>/<a href=\"$CommPath\"><b>$1<\/b><\/a>/; }
				else { $PageString =~ s/<a href="\/journals_comments\.php\?id=\d{6}&page=$MoreCounter">(\d+)<\/a>/<a href=\"$CommPath\"><b>$1<\/b><\/a>/; };

				##Deskriptor dlya zapisi kommentariya
				open(WCOMMDES, "> $CommPath") or die "$!";

				##Opredelenie kartinok v kommentariyax

				##Razbienie poluchennogo kontenta na otdel'nye stroki
				my @Arr = split(/\n/, $CommResp->content);
			   
			   ##Zakachka kartinok
				foreach $CommString (@Arr)
				{
					if ($CommString =~ /<img src="(.+\.[\w]+)" .*>/)
					{
						$Buff = $1;

						##Dlya vneshnix kartinok
						if ($Buff =~ /http:.+/)
						{

							my $PicCommOutReq = HTTP::Request->new(GET=>"$Buff");
							my $PicCommOutRes = $ua->request($PicCommOutReq);

							if ($PicCommOutRes->is_success)
							{
								my $PicName = basename($Buff);
								my $PicPath = File::Spec->catfile($CommDir, $PicDir2, $PicName);

								##Udalenie dubley
								while (1)
								{
									if ( -e $PicPath) 
									{ 
										my $s = -s $PicPath;
										last if ($PicCommOutRes->content_length == $s);
									
										$PicName =~ /(\.\w+)/;
										$AddExt = $1;
										$PicName =~ s/(.+)\.\w+/$1/;
										$PicName .= '1' . $AddExt;
										$PicPath = File::Spec->catfile($CommDir, $PicDir2, $PicName);
									}
									else { last; };
								};
							
								##Lokal'nyi adres kartinki
								my $PicPathLink =  $PicDir2.'/'.$PicName;
							
								##Zapis' kartinki v fayl
								open(CPIC1, ">", $PicPath) or die "$!";
								binmode CPIC1; 	##Dlya OS Windows neobxodim binarnyi rezhim zapisi kartinok
								print CPIC1 $PicCommOutRes->content;
								close(CPIC1);
								##Zapis' lokal'nogo adresa
								$CommString =~ s/<img src=".+"(.*)>/<img src=\"$PicPathLink\"$1>/;
							}
							else { print "\n Picture Not Found"; };
						} ##Dlya kartinok s servera
						else
						{
							$PicLocalUrl = $JRU.$Buff;
							my $PicCommLocalReq = HTTP::Request->new(GET=>$PicLocalUrl);
							my $PicCommLocalRes = $ua->request($PicCommLocalReq);
						
							if ($PicCommLocalRes->is_success)
							{
								$PicName = basename($Buff);
								my $PicPath = File::Spec->catfile($CommDir, $PicDir2, $PicName);
							
								while (1)
								{
									if ( -e $PicPath) 
									{ 
								 		my $s = -s $PicPath;
										last if ( $PicCommLocalRes->content_length == $s);
									
										$PicName =~ /(\.\w+)/;
										$AddExt = $1;
										$PicName =~ s/([\w\d]+)\.\w+/$1/;
										$PicName =~ s/([\d\w]+)\.\w+/$1/;
										$PicName .= '1' . $AddExt;
										$PicPath = File::Spec->catfile($CommDir, $PicDir2, $PicName);
									}
									else { last; };
								};
							
								my $PicPathLink =  $PicDir2.'/'.$PicName;
							
								open(CPIC2, ">", $PicPath) or die "$!";
								binmode CPIC2;
								print CPIC2 $PicCommLocalRes->content;
								close(CPIC2);
								$CommString =~ s/<img src=".+"(.*)>/<img src=\"$PicPathLink\"$1>/;
							}
							else { print "\nPicture Not Found"; };
						};
					};
					print WCOMMDES $CommString;
				};
				close(WCOMMDES);
			};
			while (@MoreCommURLArr) { shift(@MoreCommURLArr); };
		};
		
		##Opredelenie kartinki na stranice
		if ($PageString =~ /<img src="(.+\.[\w]+)" .*>/)
		{
			$Buff = $1;
			
			if ($Buff =~ /http:.+/)
			{
				my $PicPageOutReq = HTTP::Request->new(GET=>"$Buff");;
				my $PicPageOutRes = $ua->request($PicPageOutReq);
				
				if ($PicPageOutRes->is_success)
				{
					$PicName = basename($Buff);
					$PicPath = File::Spec->catfile($PicDir, $PicName);
					open(PPIC, ">", $PicPath) or die "$!";
				 	binmode PPIC;
					print PPIC $PicPageOutRes->content;
					close(PPIC);
					$PicPath =~ s/\\/\//;
					$PageString =~ s/<img src=".+"(.*)>/<img src=\"$PicPath\"$1>/;
				};
			}
			else
			{
				$PicLocalUrl = $JRU.$Buff;
				my $PicPageLocalReq = HTTP::Request->new(GET=>$PicLocalUrl);
				my $PicPageLocalRes = $ua->request($PicPageLocalReq);
				
				if ($PicPageLocalRes->is_success)
				{
					$PicName = basename($Buff);
					$PicPath = File::Spec->catfile($PicDir, $PicName);
					open(PPIC, ">", $PicPath) or die "$!";
					binmode PPIC;
					print PPIC $PicPageLocalRes->content;
					close(PPIC);
					$PicPath =~ s/\\/\//;
					$PageString =~ s/<img src=".+"(.*)>/<img src=\"$PicPath\"$1>/;
				};
			};
		};
		
		print WPAGE $PageString;
		
		##Opredelenie posledney stranicy
		if ($PageString =~ m/.*<div align="center" class="j_txt">.*/)
		{
			$JEnd = 1;
			unlink($PageFileNameW);
		};
  	};
	close(WPAGE);
	$JPage++;		##Sleduyush'aya stranica
};


##END##
